import 'package:equatable/equatable.dart';
import 'package:zhiying_comm/pages/login_page/model/login_model.dart';

abstract class LoginState extends Equatable {
  const LoginState();

  @override
  List<Object> get props => [];
}

/// 初始化状态
class InitialLoginState extends LoginState {}

/// 缓存数据状态
class LoginCacheState extends LoginState {
  final LoginModel model;
  const LoginCacheState({this.model});
  @override
  List<Object> get props => [this.model];
}

/// 数据加载完毕状态
class LoginLoadedState extends LoginState {
  final LoginModel model;
  const LoginLoadedState({this.model});
  @override
  List<Object> get props => [this.model];
}

/// 数据加载出错
class LoginErrorState extends LoginState {}
